﻿wevtutil qe "Microsoft-Windows-DNSServer/Analytical" /q:"*[System[(EventID=256 or EventID=257)]]" /f:text > wev-test1.txt
wevtutil cl "Microsoft-Windows-DNSServer/Analytical"

$tempfile = "c:\DNSarchive\wev-test1.txt"
$filename = "c:\DNSarchive\wev" + (get-date -format MM-dd-yyyy-HH-mm) + ".txt"

$infile = [System.IO.StreamReader] $tempfile
$outfile = [System.IO.StreamWriter] $filename

# Put heading line in the csv
$outfile.WriteLine("timestamp, sourceIP, request,query/response, packetData")

while (($line = $infile.ReadLine()) -ne $null) {
    if ($line -like "*Date:*") {
       $timestamp = $($line.split(" "))[3]
       $timestamp = $timestamp.Replace('T', ' ')
    }
    elseif ($line -like "RESPONSE_SUCCESS:*") {
       $tmp = $line.Split(";")
       $sourceIP = (($tmp[2]).Split("="))[1]
       $request = (($tmp[5]).Split("="))[1]
       $packetData = (($tmp[14]).Split("="))[1]
       $outfile.WriteLine($timestamp+","+$sourceIP+","+$request+",R,"+$packetData)
    }
    elseif ($line -like "QUERY_RECEIVED:*") {
       $tmp = $line.Split(";")
       $sourceIP = (($tmp[2]).Split("="))[1]
       $request = (($tmp[4]).Split("="))[1]
       $packetData = (($tmp[9]).Split("="))[1]
       $outfile.WriteLine($timestamp+","+$sourceIP+","+$request+",Q,"+$packetData)
    }
}
$infile.Dispose()
$outfile.Close()

