﻿
#The DNS control panel is set to send debug logs to c:\DNSarchive\DNSlog.txt
#
#This script parses the current log file and copies it to something like 06-15-2012-23-59.txt
#
$tempfile = "c:\DNSarchive\temp.txt"
$filename = "c:\DNSarchive\" + (get-date -format MM-dd-yyyy-HH-mm) + ".txt"
#
stop-service dns
copy c:\dnsarchive\dnslog.txt $tempfile
start-service dns


$infile = [System.IO.StreamReader] $tempfile
$outfile = [System.IO.StreamWriter] $filename

# Put heading line in the csv
$outfile.WriteLine("timestamp, sourceIP, request")

# this regex picks out 
#   time 10/21/2016 3:17:22 PM, saved as $timestamp
#   IP only for requests fron clients, Rcv 10.48.0-7.x, saved as $sourceIP
#     note: change the regex to match your network
#   fqdn requested, (3)ssl(16)google-analytics(3)com(0), saved as $URL
#     (#) changed to . later on
#     saved as request in the final csv file, sorry

$Regex = '(^\d*/\d*/\d*\s+\d*:\d*:\d*\s+..).+Rcv\s(10.48.[0-7].\d+).+\sA\s+(\(.+$)'

# initialize variables so we can remove consequtive duplicate lines
$oldTimeStamp = $oldSourceIP = $OldURL = $null


while (($line = $infile.ReadLine()) -ne $null) {
    if ($line -match $Regex) {
       $timestamp = $Matches[1]
       $sourceIP = $Matches[2]
       $URL = ($Matches[3]  -replace "\(\d+\)", ".").Trim(".")
       if (!($oldTimeStamp -eq $timestamp -and $oldSourceIP -eq $sourceIP `
            -and $OldURL -eq $URL)) {
          $outfile.WriteLine($timestamp+","+$sourceIP+","+$URL)
        }
        $oldTimeStamp = $timestamp
        $oldSourceIP = $sourceIP
        $OldURL = $URL
    }
}
$infile.Dispose()
$outfile.Close()

del $tempfile
#
#This deletes files older than 14 days
#
dir C:\DNSarchive | where-object {$_.lastwritetime -lt (get-date).addDays(-14)} | Remove-Item
#


